import com.cycling74.max.*;
import com.cycling74.jitter.*;
import static java.lang.Math.*;

public class lcdJit extends MaxObject
{		
	private static final String[] INLET_ASSIST = new String[]{
	"inlet 1 help"
	};
	private static final String[] OUTLET_ASSIST = new String[]{
	"outlet 1 help"
	};
	
	JitterObject sketch;
	JitterObject render;
	
	
	public lcdJit(Atom[] args)
	{
		declareInlets(new int[]{DataTypes.ALL});
		declareOutlets(new int[]{DataTypes.ALL,DataTypes.ALL});
		
		setInletAssist(INLET_ASSIST);
		setOutletAssist(OUTLET_ASSIST);
		
		
		
		sketch = new JitterObject("jit.gl.sketch", "cross");
		sketch.setAttr("depth_enable", 0);
		sketch.setAttr("blend_enable", 1);
		//sketch.setAttr("automatic", 1);
		//sketch.setAttr("antialias", 1);
		sketch.call("shapeslice", new int[]{10,10});
		
		render = new JitterObject("jit.gl.render", "cross");
		//render.setAttr("depth_enable", 0);
		//render.setAttr("blend_enable", 1);
		//render.setAttr("fsaa", 1);
		//render.setAttr("automatic", 1);
		//render.setAttr("erase_color", new float[]{1f,1f,1f,1f});
	}
	
	public void drawTimes()
	{
		drawLCD(64, 64);
		drawSketch(0, 0);
	}

	public void mouseJit(Atom[] xy)
	{
		drawSketch(xy[0].getFloat(), xy[1].getFloat());
	}
	
	public void mouseLCD(Atom[] xy)
	{
		drawLCD(xy[0].getInt(), xy[1].getInt());
	}
	
	public void drawLCD(int x, int y)
	{
		outlet(0, "clear");
		outlet(0, new Atom[]{Atom.newAtom("frgb"), Atom.newAtom(0), Atom.newAtom(0), Atom.newAtom(0)});
		outlet(0, new Atom[]{Atom.newAtom("linesegment"), Atom.newAtom(x-2), Atom.newAtom(y), Atom.newAtom(x+2), Atom.newAtom(y)});
		outlet(0, new Atom[]{Atom.newAtom("linesegment"), Atom.newAtom(x), Atom.newAtom(y+2), Atom.newAtom(x), Atom.newAtom(y-2)});
	}
	
	public void drawSketch(float x, float y)
	{
		outlet(1, "reset");
		outlet(1, new Atom[]{Atom.newAtom("linesegment"), Atom.newAtom(x-0.02), Atom.newAtom(y), Atom.newAtom(0), Atom.newAtom(x+0.02), Atom.newAtom(y), Atom.newAtom(0)});
		outlet(1, new Atom[]{Atom.newAtom("linesegment"), Atom.newAtom(x), Atom.newAtom(y+0.02), Atom.newAtom(0), Atom.newAtom(x), Atom.newAtom(y-0.02), Atom.newAtom(0)});
	}

}